/*Program 2015/4/20: Mixed filters function*/
#include <stdio.h>
#include "mbed.h"
Serial pc(USBTX, USBRX);
//------------------------------------------------------------------[mbed objects]
AnalogIn Ain(p20);
AnalogOut Aout(p18);
Ticker sample20kHz_tick;
//------------------------------------------------------------------[function prototypes]
float FIRLPF1(float FIRLPF_in);
float FIRLPF2(float FIRLPF_in);
float FIRLPF3(float FIRLPF_in);
float FIRHPF1(float FIRHPF_in);
float FIRHPF2(float FIRHPF_in);
float FIRHPF3(float FIRHPF_in);
float IIRLPF1(float IIRLPF_in);
float IIRLPF2(float IIRLPF_in);
float IIRLPF3(float IIRLPF_in);
float IIRHPF1(float IIRHPF_in);
float IIRHPF2(float IIRHPF_in);
float IIRHPF3(float IIRHPF_in);
void sample20kHz_task(void);
//------------------------------------------------------------------[data variables]
float data_in, data_out;
//------------------------------------------------------------------[main function]
int main()
{
	sample20kHz_tick.attach_us(&sample20kHz_task, 50);//attach task to 50us tick  
}
//------------------------------------------------------------------[sampling and control function]
void sample20kHz_task(void)
{
	data_in = Ain - 0.5;
	int Option = 0;
	int type1 = 0;
	int type2 = 0;
	int type3 = 0;
	int type4 = 0;
	pc.printf("1. FIR_LPF; 2. FIR_HPF;3. IIR_LPF; 4. IIR_HPF;\n\r");
	pc.printf("Please enter the type you want: \n\r");
	pc.scanf("%d", &Option);
	pc.printf("Your choice is: %d;\n\r", Option);
	switch (Option)//The options of the filter types;
	{
		//------------------------------------------------------------------[FIRLPF]
	case 1:
		pc.printf("You choice is: FIR_LPF\n\r");
		pc.printf("Please enter your pereference of the function type: \n\r");
		pc.printf("1. equiripple; 2. hamming; 3. kaiser;\n\r");
		pc.scanf("%d", &type1);
		pc.printf("Your choice is: %d\n\r", type1);
		switch (type1)//The options of function types;
		{
		case 1:pc.printf("Your choice is: equiripple.\n\r"); data_out = FIRLPF1(data_in); break;
		case 2:pc.printf("Your choice is: hamming.\n\r"); data_out = FIRLPF2(data_in); break;
		case 3:pc.printf("Your choice is: kaiser.\n\r"); data_out = FIRLPF3(data_in); break;
		default:printf("Please type effective number!\n\r");
		}
		break;
		//------------------------------------------------------------------[FIRHPF]
	case 2:
		pc.printf("You choice is: FIR_HPF\n\r");
		pc.printf("Please enter your pereference of the function type: \n\r");
		pc.printf("1. equiripple; 2. hamming; 3. kaiser;\n\r");
		pc.scanf("%d", &type2);
		pc.printf("Your choice is: %d\n\r", type2);
		switch (type2)//The options of function types;
		{
		case 1:pc.printf("Your choice is: equiripple.\n\r"); data_out = FIRHPF1(data_in); break;
		case 2:pc.printf("Your choice is: hamming.\n\r"); data_out = FIRHPF2(data_in); break;
		case 3:pc.printf("Your choice is: kaiser.\n\r"); data_out = FIRHPF3(data_in); break;
		default:printf("Please type effective number!\n\r");
		}
		break;
		//------------------------------------------------------------------[IIRLPF]
	case 3:
		pc.printf("You choice is: IIR_LPF\n\r");
		pc.printf("Please enter your pereference of the function type: \n\r");
		pc.printf("1. butterworth; 2. chebyshev I; 3. chebyshev II;\n\r");
		pc.scanf("%d", &type3);
		pc.printf("Your choice is: %d\n\r", type3);
		switch (type3)//The options of function types;
		{
		case 1:pc.printf("Your choice is: butterworth.\n\r"); data_out = IIRLPF1(data_in); break;
		case 2:pc.printf("Your choice is: chebyshev I.\n\r"); data_out = IIRLPF2(data_in); break;
		case 3:pc.printf("Your choice is: chebyshev II.\n\r"); data_out = IIRLPF3(data_in); break;
		default:printf("Please type effective number!\n\r");
		}
		break;
		//------------------------------------------------------------------[IIRHPF]
	case 4:
		pc.printf("You choice is: IIR_HPF\n\r");
		pc.printf("Please enter your pereference of the function type: \n\r");
		pc.printf("1. butterworth; 2. chebyshev I; 3. chebyshev II;\n\r");
		pc.scanf("%d", &type4);
		pc.printf("Your choice is: %d\n\r", type4);
		switch (type3)//The options of function types;
		{
		case 1:pc.printf("Your choice is: butterworth.\n\r"); data_out = IIRHPF1(data_in); break;
		case 2:pc.printf("Your choice is: chebyshev I.\n\r"); data_out = IIRHPF2(data_in); break;
		case 3:pc.printf("Your choice is: chebyshev II.\n\r"); data_out = IIRHPF3(data_in); break;
		default:printf("Please type effective number!\n\r");
		}
		break;
	default:printf("Please type effective number!\n\r");
		printf("Please type effective number!\n\r");
	}
	Aout = data_out + 0.5;
}
//------------------------------------------------------------------[FIR_LPF/equiripple]
float FIRLPF1(float FIRLPF_in)
{
	//equiripple[order--28];  
	float a[29] =
	{ 0.0024799863264243103,
	0.0037842638319847783,
	0.0063627484388640663,
	0.0097697503040806398,
	0.014016752378272079,
	0.019047901542890929,
	0.024727325496954038,
	0.030849250356305404,
	0.037137805098497977,
	0.043274107130853487,
	0.048917245722813425,
	0.053728507491069215,
	0.057407658988753066,
	0.059717305579106934,
	0.060504593564029867,
	0.059717305579106934,
	0.057407658988753066,
	0.053728507491069215,
	0.048917245722813425,
	0.043274107130853487,
	0.037137805098497977,
	0.030849250356305404,
	0.024727325496954038,
	0.019047901542890929,
	0.014016752378272079,
	0.0097697503040806398,
	0.0063627484388640663,
	0.0037842638319847783,
	0.0024799863264243103 };  //Numerator

	static float FIRLPF_out = 0;
	static float x[29] =
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0 };
	float y = 0;

	for (int i = 28; i>0; i--)
		x[i] = x[i - 1];            //move x values by one sample

	x[0] = FIRLPF_in;         // new value for x[0]

	for (int j = 0; j <= 28; j++)    //formula of the filter
		y = y + (a[j] * x[j]);

	FIRLPF_out = y;
	return FIRLPF_out;        // output filtered value
}
//------------------------------------------------------------------[FIR_LPF/hamming]
float FIRLPF2(float FIRLPF_in)
{
	//hamming[order--45];  
	float a[46] =
	{ -0.0011135204660955673,
	-0.0012653307384166569,
	-0.0015049180471947085,
	-0.0018029344664338308,
	-0.0020869004532157575,
	-0.002242558033060128,
	-0.0021208895867262634,
	-0.00155045023588037,
	-0.0003540273764900339,
	0.0016319114360222443,
	0.0045369261778831181,
	0.0084376190039695664,
	0.013342087207774474,
	0.019179693049982335,
	0.025797563743371627,
	0.032964601346909934,
	0.040383044172367641,
	0.047706854970006866,
	0.054565497640177978,
	0.060591080278460718,
	0.065446452069997954,
	0.068851689128110335,
	0.070606509178478535,
	0.070606509178478535,
	0.068851689128110335,
	0.065446452069997954,
	0.060591080278460718,
	0.054565497640177978,
	0.047706854970006866,
	0.040383044172367641,
	0.032964601346909934,
	0.025797563743371627,
	0.019179693049982335,
	0.013342087207774474,
	0.0084376190039695664,
	0.0045369261778831181,
	0.0016319114360222443,
	-0.0003540273764900339,
	-0.00155045023588037,
	-0.0021208895867262634,
	-0.002242558033060128,
	-0.0020869004532157575,
	-0.0018029344664338308,
	-0.0015049180471947085,
	-0.0012653307384166569,
	-0.0011135204660955673 };  //Numerator

	static float FIRLPF_out = 0;
	static float x[46] =
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
	float y = 0;

	for (int i = 45; i>0; i--)
		x[i] = x[i - 1];            //move x values by one sample

	x[0] = FIRLPF_in;         // new value for x[0]

	for (int j = 0; j <= 45; j++)    //formula of the filter
		y = y + (a[j] * x[j]);

	FIRLPF_out = y;
	return FIRLPF_out;        // output filtered value
}
//------------------------------------------------------------------[FIR_LPF/kaiser]
float FIRLPF3(float FIRLPF_in)
{
	//kaiser[order--52];  
	float a[53] =
	{ 0.000061946506721966585,
	-0.0000000000000000001078614605208796,
	-0.00017317973410657439,
	-0.00049578000091614295,
	-0.00099385455105554686,
	-0.0016709639425174175,
	-0.0024980960237598049,
	-0.0034055360435935327,
	-0.0042783995205550171,
	-0.0049573235795750594,
	-0.0052453300590547085,
	-0.0049211640952775007,
	-0.003758553023452892,
	-0.0015499320823100296,
	0.0018676269059234767,
	0.0065871428778999444,
	0.012610240750580046,
	0.019832467580658032,
	0.028037894013545415,
	0.0369045858958282,
	0.046021355153047352,
	0.054914886253029885,
	0.063085051098626235,
	0.07004514174895371,
	0.075363017895838325,
	0.0786988935166993,
	0.07983572491764479,
	0.0786988935166993,
	0.075363017895838325,
	0.07004514174895371,
	0.063085051098626235,
	0.054914886253029885,
	0.046021355153047352,
	0.0369045858958282,
	0.028037894013545415,
	0.019832467580658032,
	0.012610240750580046,
	0.0065871428778999444,
	0.0018676269059234767,
	-0.0015499320823100296,
	-0.003758553023452892,
	-0.0049211640952775007,
	-0.0052453300590547085,
	-0.0049573235795750594,
	-0.0042783995205550171,
	-0.0034055360435935327,
	-0.0024980960237598049,
	-0.0016709639425174175,
	-0.00099385455105554686,
	-0.00049578000091614295,
	-0.00017317973410657439,
	-0.0000000000000000001078614605208796,
	0.000061946506721966585 };  //Numerator

	static float FIRLPF_out = 0;
	static float x[53] =
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0 };
	float y = 0;

	for (int i = 52; i>0; i--)
		x[i] = x[i - 1];            //move x values by one sample

	x[0] = FIRLPF_in;         // new value for x[0]

	for (int j = 0; j <= 52; j++)    //formula of the filter
		y = y + (a[j] * x[j]);

	FIRLPF_out = y;
	return FIRLPF_out;        // output filtered value
}
//------------------------------------------------------------------[FIR_HPF/equiripple]
float FIRHPF1(float FIRHPF_in)
{
	//equiripple[order--30];  
	float a[31] =
	{ 0.015160063158327857,
	0.0081846197303405838,
	0.0086259133921778273,
	0.0075323978302696262,
	0.00442337163473448,
	-0.00096338995208121263,
	-0.0087239073763374104,
	-0.018720852620249185,
	-0.030556551321839594,
	-0.043589947736838955,
	-0.056983367203397445,
	-0.069782632420204715,
	-0.081015548189240269,
	-0.089785354308991622,
	-0.095363393626163029,
	0.90272307169281829,
	-0.095363393626163029,
	-0.089785354308991622,
	-0.081015548189240269,
	-0.069782632420204715,
	-0.056983367203397445,
	-0.043589947736838955,
	-0.030556551321839594,
	-0.018720852620249185,
	-0.0087239073763374104,
	-0.00096338995208121263,
	0.00442337163473448,
	0.0075323978302696262,
	0.0086259133921778273,
	0.0081846197303405838,
	0.015160063158327857 };//Numerator

	static float FIRHPF_out = 0;
	static float x[31] =
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0 };
	float y = 0;

	for (int i = 30; i>0; i--)
		x[i] = x[i - 1];            //move x values by one sample

	x[0] = FIRHPF_in;         // new value for x[0]

	for (int j = 0; j <= 30; j++)    //formula of the filter
		y = y + (a[j] * x[j]);

	FIRHPF_out = y;
	return FIRHPF_out;        // output filtered value
}
//------------------------------------------------------------------[FIRHPF/hamming]
float FIRHPF2(float FIRHPF_in)
{
	//hamming[order--55];  
	float a[56] =
	{ -0.00090122507408516115,
	-0.00089610311211727248,
	-0.00089662642134904569,
	-0.00086796324707592051,
	-0.00075865643862259649,
	-0.00050583044902078299,
	-0.000042803334499179505,
	0.00069148891085133899,
	0.0017420698450089039,
	0.0031274611461800336,
	0.0048301899850315896,
	0.0067892119305964548,
	0.0088950205098246807,
	0.010987925466655795,
	0.012859582652000151,
	0.014257346620353367,
	0.014890366750438679,
	0.014435475180206395,
	0.012539598313346667,
	0.0088131070254204927,
	0.0028037824294849197,
	-0.0060699597563530997,
	-0.018676930483817016,
	-0.036559570407746045,
	-0.062997992438162398,
	-0.10663544425094884,
	-0.19959408868341399,
	-0.63287485744581584,
	0.63287485744581584,
	0.19959408868341399,
	0.10663544425094884,
	0.062997992438162398,
	0.036559570407746045,
	0.018676930483817016,
	0.0060699597563530997,
	-0.0028037824294849197,
	-0.0088131070254204927,
	-0.012539598313346667,
	-0.014435475180206395,
	-0.014890366750438679,
	-0.014257346620353367,
	-0.012859582652000151,
	-0.010987925466655795,
	-0.0088950205098246807,
	-0.0067892119305964548,
	-0.0048301899850315896,
	-0.0031274611461800336,
	-0.0017420698450089039,
	-0.00069148891085133899,
	0.000042803334499179505,
	0.00050583044902078299,
	0.00075865643862259649,
	0.00086796324707592051,
	0.00089662642134904569,
	0.00089610311211727248,
	0.00090122507408516115 };//Numerator

	static float FIRHPF_out = 0;
	static float x[56] =
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
	float y = 0;

	for (int i = 55; i>0; i--)
		x[i] = x[i - 1];            //move x values by one sample

	x[0] = FIRHPF_in;         // new value for x[0]

	for (int j = 0; j <= 55; j++)    //formula of the filter
		y = y + (a[j] * x[j]);

	FIRHPF_out = y;
	return FIRHPF_out;        // output filtered value
}
//------------------------------------------------------------------[FIRHPF/kaiser]
float FIRHPF3(float FIRHPF_in)
{
	//kaiser[order--52];  
	float a[53] =
	{ -0.000062078346604685231,
	-0.00000000000000000010863735153773232,
	0.00017354831010935653,
	0.00049683516254889334,
	0.00099596975777799766,
	0.0016745202316750755,
	0.002503412686542303,
	0.0034127839982619249,
	0.0042875051783372838,
	0.0049678741819240728,
	0.0052564936215605739,
	0.0049316377399025359,
	0.0037665522992156161,
	0.00155323078105459,
	-0.0018716017501119874,
	-0.0066011622018365169,
	-0.012637078949368016,
	-0.019874676743663923,
	-0.028097566670714676,
	-0.036983129409155886,
	-0.046119301758708438,
	-0.055031760836380547,
	-0.06321931412939788,
	-0.070194217843182999,
	-0.075523411951396335,
	-0.078866387269623459,
	0.9200648389885655,
	-0.078866387269623459,
	-0.075523411951396335,
	-0.070194217843182999,
	-0.06321931412939788,
	-0.055031760836380547,
	-0.046119301758708438,
	-0.036983129409155886,
	-0.028097566670714676,
	-0.019874676743663923,
	-0.012637078949368016,
	-0.0066011622018365169,
	-0.0018716017501119874,
	0.00155323078105459,
	0.0037665522992156161,
	0.0049316377399025359,
	0.0052564936215605739,
	0.0049678741819240728,
	0.0042875051783372838,
	0.0034127839982619249,
	0.002503412686542303,
	0.0016745202316750755,
	0.00099596975777799766,
	0.00049683516254889334,
	0.00017354831010935653,
	-0.00000000000000000010863735153773232,
	-0.000062078346604685231 };//Numerator

	static float FIRHPF_out = 0;
	static float x[53] =
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0 };
	float y = 0;

	for (int i = 52; i>0; i--)
		x[i] = x[i - 1];            //move x values by one sample

	x[0] = FIRHPF_in;         // new value for x[0]

	for (int j = 0; j <= 52; j++)    //formula of the filter
		y = y + (a[j] * x[j]);

	FIRHPF_out = y;
	return FIRHPF_out;        // output filtered value
}
//------------------------------------------------------------------[IIRLPF/butterworth]
float IIRLPF1(float IIRLPF_in)
{
	//butterworth;  
	float a[4] = { 0.000013188957001879547, 0.00003956687100563864, 0.00003956687100563864, 0.000013188957001879547 };//Numerator
	float b[4] = { 1, -2.9039961248322808, 2.8125453931815168, -0.90844375669322119 };//Denominator

	static float IIRLPF_out = 0;
	static float x[4] = { 0, 0, 0, 0 };
	static float y[4] = { 0, 0, 0, 0 };

	x[3] = x[2]; x[2] = x[1]; x[1] = x[0];  //move x values by one sample
	y[3] = y[2]; y[2] = y[1]; y[1] = y[0];  //move y values by one sample

	x[0] = IIRLPF_in;                          // new value for x[0] 
	y[0] = (a[0] * x[0]) + (a[1] * x[1]) + (a[2] * x[2]) + (a[3] * x[3]) - (b[1] * y[1]) - (b[2] * y[2]) - (b[3] * y[3]);

	IIRLPF_out = y[0];
	return IIRLPF_out;                         // output filtered value
}
//------------------------------------------------------------------[IIRLPF/chebyshev I]
float IIRLPF2(float IIRLPF_in)
{
	//chebyshev I;  
	float a[4] = { 0.000013212400558242652, 0.000039637201674727957, 0.000039637201674727957, 0.000013212400558242652 };//Numerator
	float b[4] = { 1, -2.9136211313462415, 2.8316261271374117, -0.91789929658670455 };//Denominator

	static float IIRLPF_out = 0;
	static float x[4] = { 0, 0, 0, 0 };
	static float y[4] = { 0, 0, 0, 0 };

	x[3] = x[2]; x[2] = x[1]; x[1] = x[0];  //move x values by one sample
	y[3] = y[2]; y[2] = y[1]; y[1] = y[0];  //move y values by one sample

	x[0] = IIRLPF_in;                          // new value for x[0] 
	y[0] = (a[0] * x[0]) + (a[1] * x[1]) + (a[2] * x[2]) + (a[3] * x[3]) - (b[1] * y[1]) - (b[2] * y[2]) - (b[3] * y[3]);

	IIRLPF_out = y[0];
	return IIRLPF_out;                         // output filtered value
}
//------------------------------------------------------------------[IIRLPF/chebyshev II]
float IIRLPF3(float IIRLPF_in)
{
	//chebyshev II;  
	float a[4] = { 0.00071885171857367989, -0.00051364567876175868, -0.00051364567876175868, 0.00071885171857367989 };//Numerator
	float b[4] = { 1, -2.8481410544421251, 2.7075989929970059, -0.85904752647525706 };//Denominator

	static float IIRLPF_out = 0;
	static float x[4] = { 0, 0, 0, 0 };
	static float y[4] = { 0, 0, 0, 0 };

	x[3] = x[2]; x[2] = x[1]; x[1] = x[0];  //move x values by one sample
	y[3] = y[2]; y[2] = y[1]; y[1] = y[0];  //move y values by one sample

	x[0] = IIRLPF_in;                          // new value for x[0] 
	y[0] = (a[0] * x[0]) + (a[1] * x[1]) + (a[2] * x[2]) + (a[3] * x[3]) - (b[1] * y[1]) - (b[2] * y[2]) - (b[3] * y[3]);

	IIRLPF_out = y[0];
	return IIRLPF_out;                         // output filtered value
}
//------------------------------------------------------------------[IIRHPF/butterworth]
float IIRHPF1(float IIRHPF_in)
{
	//butterworth;  
	float a[4] = { 0.73130532173784046, -2.1939159652135212, 2.1939159652135212, -0.73130532173784046 };//Numerator
	float b[4] = { 1, -2.3790815311969635, 1.9365616067820404, -0.53479943592371992 };//Denominator

	static float IIRHPF_out = 0;
	static float x[4] = { 0, 0, 0, 0 };
	static float y[4] = { 0, 0, 0, 0 };

	x[3] = x[2]; x[2] = x[1]; x[1] = x[0];  //move x values by one sample
	y[3] = y[2]; y[2] = y[1]; y[1] = y[0];  //move y values by one sample

	x[0] = IIRHPF_in;                          // new value for x[0] 
	y[0] = (a[0] * x[0]) + (a[1] * x[1]) + (a[2] * x[2]) + (a[3] * x[3]) - (b[1] * y[1]) - (b[2] * y[2]) - (b[3] * y[3]);

	IIRHPF_out = y[0];
	return IIRHPF_out;                         // output filtered value
}
//------------------------------------------------------------------[IIRHPF/chebyshev I]
float IIRHPF2(float IIRHPF_in)
{
	//chebyshev I;  
	float a[4] = { 0.74096279368702966, -2.2228883810610891, 2.2228883810610891, -0.74096279368702966 };//Numerator
	float b[4] = { 1, -2.4049287841756017, 1.9753782681768497, -0.54739529714378565 };//Denominator

	static float IIRHPF_out = 0;
	static float x[4] = { 0, 0, 0, 0 };
	static float y[4] = { 0, 0, 0, 0 };

	x[3] = x[2]; x[2] = x[1]; x[1] = x[0];  //move x values by one sample
	y[3] = y[2]; y[2] = y[1]; y[1] = y[0];  //move y values by one sample

	x[0] = IIRHPF_in;                          // new value for x[0] 
	y[0] = (a[0] * x[0]) + (a[1] * x[1]) + (a[2] * x[2]) + (a[3] * x[3]) - (b[1] * y[1]) - (b[2] * y[2]) - (b[3] * y[3]);

	IIRHPF_out = y[0];
	return IIRHPF_out;                         // output filtered value
}
//------------------------------------------------------------------[IIRHPF/chebyshev II]
float IIRHPF3(float IIRHPF_in)
{
	//chebyshev II;  
	float a[4] = { 0.82172821958691022, -2.4645764113358455, 2.4645764113358455, -0.82172821958691022 };//Numerator
	float b[4] = { 1, -2.6078829616458794, 2.2894896673627296, -0.67523663283690305 };//Denominator

	static float IIRHPF_out = 0;
	static float x[4] = { 0, 0, 0, 0 };
	static float y[4] = { 0, 0, 0, 0 };

	x[3] = x[2]; x[2] = x[1]; x[1] = x[0];  //move x values by one sample
	y[3] = y[2]; y[2] = y[1]; y[1] = y[0];  //move y values by one sample

	x[0] = IIRHPF_in;                          // new value for x[0] 
	y[0] = (a[0] * x[0]) + (a[1] * x[1]) + (a[2] * x[2]) + (a[3] * x[3]) - (b[1] * y[1]) - (b[2] * y[2]) - (b[3] * y[3]);

	IIRHPF_out = y[0];
	return IIRHPF_out;                         // output filtered value
}